summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorDimitrios Apostolou <jimis@qt.io>2020-02-07 16:00:40 +0100
committerDimitrios Apostolou <jimis@qt.io>2020-02-15 07:38:39 +0100
commitb018b841c1ce49b412fa981a65b90a4778e933de (patch)
tree97933cdeb90c4a7af2babfa2981c72e235c0c7e0
parent25fcda6ff3346a45a1b6f76a2668e86d4c98d1ef (diff)
Do not complain about existing empty files
Sometimes we pre-create the target filename using mktemp. In that case of course the hash will not match, so avoid comparing. Change-Id: Id0feb0178d659e03f5ceb000f738167cdc28a3ec Reviewed-by: Heikki Halmet <heikki.halmet@qt.io>
-rwxr-xr-xcoin/provisioning/common/unix/DownloadURL.sh31
1 files changed, 19 insertions, 12 deletions
diff --git a/coin/provisioning/common/unix/DownloadURL.sh b/coin/provisioning/common/unix/DownloadURL.sh
index 5a3130af..1d48a565 100755
--- a/coin/provisioning/common/unix/DownloadURL.sh
+++ b/coin/provisioning/common/unix/DownloadURL.sh
@@ -100,20 +100,27 @@ DownloadURL () {
targetFile=$4
fi
- if VerifyHash "$targetFile" "$expectedHash"
+ # If a non-empty file already exists
+ if [ -s "$targetFile" ]
then
- echo "Skipping download, found and validated existing file: $targetFile"
- else
- echo "Downloading from primary URL: $url"
- if ! Download "$url" "$targetFile"
+ if VerifyHash "$targetFile" "$expectedHash"
+ then
+ echo "Skipping download, found and validated existing file: $targetFile"
+ return
+ else
+ echo "WARNING: Non-empty but different file found at destination; will re-download and overwrite file: $targetFile"
+ fi
+ fi
+
+ echo "Downloading from primary URL: $url"
+ if ! Download "$url" "$targetFile"
+ then
+ echo "FAIL! to download, trying alternative URL: $url2" 1>&2
+ if ! Download "$url2" "$targetFile"
then
- echo "FAIL! to download, trying alternative URL: $url2" 1>&2
- if ! Download "$url2" "$targetFile"
- then
- echo 'FAIL! to download even from alternative URL' 1>&2
- return 1
- fi
+ echo 'FAIL! to download even from alternative URL' 1>&2
+ return 1
fi
- VerifyHash "$targetFile" "$expectedHash"
fi
+ VerifyHash "$targetFile" "$expectedHash"
}